/*******************************************************************************
File       : CLIP2WKS.PRG
Purpose    : TransLate DBF To Lotus 123 WK1 Format
Compile    : CLIPPER CLIP2WKS /N
Link       : RTLink FI CLIP2WKS, CHRDBL
Limitation : o WK1 broken down into 256 row per file
             o Memo Field Not Translated
             o Date Field Translated Into Character
Notes      : Feel Free To Modify
Syntax     : Clip2Wks <cDBF> [cIndex] [cOutPut] [aTransLogic]
Source     : Public Domain - Modified By Andi Jahja
Web Site   : http://www.geocities.com/SiliconValley/4231/index.html
Email      : andijahj@rad.net.id
*******************************************************************************/
#define  WKS_LABELHDR     chr(15)+chr(0)
#define  WKS_NUMBERHDR    chr(14)+chr(0)+chr(13)+chr(0)
#define  LEFT_JUSTIFY     "'"
#define  STANDARD_FORMAT  chr(255)
#include "fileio.ch"
********************************************************************************
PROC MAIN
********************************************************************************
Local N
Local aDummy
dBCreate("SAMPLE.DBF",{{"NAME","C",10,0},{"BIRTH","D",8,0},{"SALARY","N",10,0},{"MARRIED","L",1,0}})
dbUseArea( .T.,,"SAMPLE.DBF","cAlias",, .F. )
For N := 1 To 254
   // Create Records For Test
   aDummy    := Array( 4 )
   aDummy[1] := "EMP" + _NEXTNUMBER( N )
   aDummy[2] := Date() + N
   aDummy[3] := 10000 + ( 10 * N )
   aDummy[4] := ( ( N%2 ) == 0 )
   cAlias->(dbAppend())
   Aeval( aDummy, { |e,n| cAlias->( FieldPut( n, e)  ) } )
Next
DBF2WKS( "SAMPLE.DBF", , "MYWKS", { {4},{{ |x,y| y := If(x,"MARRIED","SINGLE")}} } )

********************************************************************************
FUNCTION DBF2WKS( cFile, cIndex, cOut, aTransform )
********************************************************************************
Local cString
Local nField
Local nPos
Local WKSHandle
Local N
Local Col
Local aContents := {}
Local aHeader   := {}
Local Row       := 0
Local M         := 0
Local aPick     := {}
Local cOutWK1   := "CLPWK"
Local nOutPut   := 1
Local WKSFile
Local aStruct
Local bEval     := {{},{}}

If cOut != NIL .AND. ValType( cOut ) == "C"
   cOutWK1 := Left( cOut, 5 )
Endif

dbUseArea( .T.,, cFile,"cAlias",, .F. )
aStruct := cAlias->(DbStruct())

If cIndex != NIL .AND. File( cIndex )
   cAlias->(OrdListAdd( cIndex ))
Endif

If !( ValType( aTransForm ) == "A" ) .OR. Len( aTransForm ) < 2
   aTransform := {{},{}}
Endif

For N := 1 To Len( aStruct )
   If ( nField := AScan({"C","N","D","L"},ValType(cAlias->(FieldGet(N)))) ) > 0 .AND. !( aStruct[N][2] == "M" )
      If nField == 4
         If ( nPos := AScan( aTransForm[1], N ) ) > 0
            AAdd( aHeader, aStruct[N][1] )
            AAdd( aPick,    N )
            AAdd( bEval[1], N )
            AAdd( bEval[2], aTransForm[2][nPos] )
         Endif
      Else
         AAdd( aHeader, aStruct[N][1] )
         AAdd( aPick, N )
      Endif
   Endif
Next

WKSFile   := cOutWK1 + _NEXTNUMBER(nOutPut) + ".WK1"
WKSHandle := FCreate( WKSFile )
FWrite( WKSHandle, chr(0)+chr(0)+chr(2)+chr(0)+chr(4)+chr(4) )
++ row
AEval( aHeader, { |e,x| WKSWriteStr( e, "L", row, x, WKSHandle ) } )

cAlias->(dbGoTop())
While !cAlias->(Eof())
   If cAlias->(Eof())
      FWrite( WKSHandle, chr(1)+chr(0)+chr(0)+chr(0) )
      FClose( WKSHandle )
      Exit
   Endif
   If ++ row == 256
      row := 1
      FWrite( WKSHandle, chr(1)+chr(0)+chr(0)+chr(0) )
      FClose( WKSHandle )
      If cAlias->(Eof())
         Exit
      Endif
      nOutPut ++
      WKSFile   := cOutWK1 + _NEXTNUMBER(nOutPut) + ".WK1"
      WKSHandle := FCreate( WKSFile )
      FWrite( WKSHandle, chr(0)+chr(0)+chr(2)+chr(0)+chr(4)+chr(4) )
      AEval( aHeader, { |e,x| WKSWriteStr( e, "L", row, x, WKSHandle ) } )
      ++ row
   Endif

   aContents := {}
   AEval( aPick, { |e| AAdd( aContents, cAlias->(FieldGet(e)) ) } )
   for col := 1 to len( aContents )
      do case
         case valtype( aContents[col] ) == "L"
            If( nPos := AScan( bEval[1], col ) ) > 0
               Eval( bEval[2][nPos], aContents[col], @cString )
               WKSWriteStr( cString, "L", row, col, WKSHandle )
            Endif
         case valtype( aContents[col] ) == "C"
            WKSWriteStr( aContents[col], "L", row, col, WKSHandle )
         case valtype( aContents[col] ) == "D"
            WKSWriteStr( DTOC(aContents[col]), "L", row, col, WKSHandle )
         case valtype( aContents[col] ) == "N"
            WKSWriteNum( aContents[ col], row, col, WKSHandle )
      endcase
   next
   cAlias->(dbSkip(1))
Enddo
Scroll()
Alert( "Files Created : " + cOutWK1+"001.WK1"+If(nOutPut>1," - "+cOutWK1 + _NEXTNUMBER(nOutPut) + ".WK1",""),{" Ok "},"W+/B")
Return NIL

********************************************************************************
STATIC FUNCTION WKSwritestr( ostr, just, row, col, WKSHandle )
********************************************************************************
LOCAL r

just := upper( just )
ostr := trim( ostr )

// if ostr is blank, return //
if ostr == ""
   return( .t. )
endif

// Text label header, 2 chars //
r := fwrite( WKSHandle, WKS_LABELHDR )

// Text Label length, 2 chars //
r := r + fwrite( WKSHandle, chr( ( len( trim( ostr ) ) + 7 ) % 256 ) )
r := r + fwrite( WKSHandle, chr( ( len( trim( ostr ) ) + 7 ) / 256 ) )

// default cell format, 1 char //
r := r + fwrite( WKSHandle, STANDARD_FORMAT )

// cell co-ordinates, 4 chars total ( numbers in reverse byte format ! ) //
r := r + WKScoord( row, col, WKSHandle )

// Justification, 1 char //
r := r + fwrite( WKSHandle, LEFT_JUSTIFY )

// actual textual string, len(ostr) chars //
r := r + fwrite( WKSHandle, ostr, len(ostr) )

// Null termination, 1 char //
r := r + fwrite( WKSHandle, chr(0), 1)

return( r == 11+len(ostr) )

********************************************************************************
STATIC FUNCTION WKSwritenum( num, row, col, WKSHandle )
********************************************************************************
LOCAL r:=0

// Number Cell Header, 4 chars //
r := fwrite( WKSHandle, WKS_NUMBERHDR )

// cell format, 1 char //
r := r + fwrite( WKSHandle, STANDARD_FORMAT )

// Worksheet Co-Ordinates, 4 chars //
r := r + WKScoord( row, col, WKSHandle )

// Number converted to an ieee format, 8 chars //
r := r + fwrite( WKSHandle, DBL2CHR( num ) )

return( r == 17 )

********************************************************************************
STATIC FUNCTION WKScoord( row, col, WKSHandle )
********************************************************************************
LOCAL r := 0

r := fwrite( WKSHandle, chr( col-1 )+chr(0)+chr( row-1 )+chr(0) )

return( r )

********************************************************************************
STATIC FUNCTION _NEXTNUMBER( NNEXT )
********************************************************************************
if  nNext  < 1000
   if  nNext  <= 9
      return "00" + str(  nNext , 1 )
   elseif  nNext  >= 10 .and.  nNext  <= 99
      return "0" + str(  nNext , 2 )
   elseif  nNext  >= 100 .and.  nNext  <= 999
      return str(  nNext , 3 )
   endif
endif
return( "000" )
